Ice Reference Documentation
<<< Previous | Slice Documentation | Next >>>

# `Ice::Connection`

## Overview

    local interface Connection

The user-level interface to a connection.

### Used By

Current::con

### Operation Index

`close`

  Close a connection, either gracefully or forcefully.

`createProxy`

  Create a special proxy that always uses this connection.

`flushBatchRequests`

  Flush any pending batch requests for this connection.

`getAdapter`

  Get the object adapter that dispatches requests for this connection.

`setAdapter`

  Explicitly set an object adapter that dispatches requests that are received over this connection.

`timeout`

  Get the timeout for the connection.

`toString`

  Return a description of the connection as human readable text, suitable for logging or error messages.

`type`

  Return the connection type.

## `close`

    void close(bool force);

Close a connection, either gracefully or forcefully. If a connection is closed forcefully, it closes immediately, without sending the relevant close connection protocol messages to the peer and waiting for the peer to acknowledge these protocol messages.

### Parameters

`force`

  If true, close forcefully. Otherwise the connection is closed gracefully.

## `createProxy`

    Object* createProxy(Identity id);

Create a special proxy that always uses this connection. This can be used for callbacks from a server to a client if the server cannot directly establish a connection to the client, for example because of firewalls. In this case, the server would create a proxy using an already established connection from the client.

### Parameters

`id`

  The identity for which a proxy is to be created.

### Return Value

A proxy that matches the given identity and uses this connection.

### See Also

`setAdapter`

## `flushBatchRequests`

    void flushBatchRequests();

Flush any pending batch requests for this connection. This causes all batch requests that were sent via proxies that use this connection to be sent to the server.

## `getAdapter`

    ObjectAdapter getAdapter();

Get the object adapter that dispatches requests for this connection.

### Return Value

The object adapter that dispatches requests for the connection, or null if no adapter is set.

### See Also

`setAdapter`

## `setAdapter`

    void setAdapter(ObjectAdapter adapter);

Explicitly set an object adapter that dispatches requests that are received over this connection. A client can invoke an operation on a server using a proxy, and then set an object adapter for the outgoing connection that is used by the proxy in order to receive callbacks. This is useful if the server cannot establish a connection back to the client, for example because of firewalls.

### Parameters

`adapter`

  The object adapter that should be used by this connection to dispatch requests. The object adapter must be activated. When the object adapter is deactivated, it is automatically removed from the connection.

### See Also

`createProxy`, `setAdapter`

## `timeout`

    int timeout();

Get the timeout for the connection.

### Return Value

The connection's timeout.

## `toString`

    string toString();

Return a description of the connection as human readable text, suitable for logging or error messages.

### Return Value

The description of the connection as human readable text.

## `type`

    string type();

Return the connection type. This corresponds to the endpoint type, i.e., "tcp", "udp", etc.

### Return Value

The type of the connection.

<<< Previous | Home | Next >>>
`Ice::ConnectTimeoutException` | Up | `Ice::ConnectionLostException`